// ======================== Atmega128 ؽƮ LCD α׷ =====================
//  CPU : ATmega128-16M - ؽƮ LCD(4*20)
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR 
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
#include <mega128.h>							// CPU  

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>
#include <math.h>
#include <delay.h>

//  
#include "cpusetup.inc"							// cpu  ͷƮ  ƾ
#include "textlcd.inc"							// Text LCD

// Լ 
void main_menu_disp(void);						//  ޴ ǥ

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
char lcd_buf[25];
	
	cpu_setup();							// cpu ʱȭ
	LCD_Init();							// LCD ʱȭ
	main_menu_disp();						//  ޴ ǥ
	Putsxyt_f(1,1,"  MEGA128_Clcd  ");
	Putsxyt_f(1,2,"www.cpuplaza.com");
	while(1){
		if(com1_rx_eflg){					// COM1  ˻
			if(com1_rx_data == '1') Clrscr();		// ȭ 
			else if(com1_rx_data == '2') Putch('1');	// 1 ǥ
			else if(com1_rx_data == '3') Putchxyt(1,1,'3');	// ؽƮ ǥ 1 ǥ
			else if(com1_rx_data == '4'){
				sprintf(lcd_buf,"123");			// ǥ ڿ
				Puts(lcd_buf);
			}
			else if(com1_rx_data == '5'){			// ؽƮ ǥ ڿ ǥ
				sprintf(lcd_buf,"LCD TEST LINE1");	// ǥ ڿ
				Putsxyt(4,1,lcd_buf);
				sprintf(lcd_buf,"LCD TEST LINE2");	// ǥ ڿ
				Putsxyt(4,2,lcd_buf);
				sprintf(lcd_buf,"LCD TEST LINE3");	// ǥ ڿ
				Putsxyt(4,3,lcd_buf);
				sprintf(lcd_buf,"LCD TEST LINE4");	// ǥ ڿ
				Putsxyt(4,4,lcd_buf);
			}
			else if(com1_rx_data == '6') Puts_f("123");	// ǥ ڿ(FLASH)
			else if(com1_rx_data == '7'){			// ؽƮ ǥ ڿ(FLASH) ǥ
				Putsxyt_f(4,1,"LCD TEST LINE1");
				Putsxyt_f(4,2,"LCD TEST LINE2");
				Putsxyt_f(4,3,"LCD TEST LINE3");
				Putsxyt_f(4,4,"LCD TEST LINE4");
			}
			else if(com1_rx_data == '8') Cursor_Set(ON);	// Ŀ ON
			else if(com1_rx_data == '9') Cursor_Set(OFF);	// Ŀ OFF
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
	return 0;
}

// =====================================  ޴ ǥ =======================
// [μ] void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("========== LCD Test Main =========\r\n");
	printf("- 1 : Clrscr                     -\r\n");
	printf("- 2 : Putch                      -\r\n");
	printf("- 3 : Putchxyt                   -\r\n");
	printf("- 4 : Puts                       -\r\n");
	printf("- 5 : Putsxyt                    -\r\n");
	printf("- 6 : Puts_f                     -\r\n");
	printf("- 7 : Putsxyt_f                  -\r\n");
	printf("- 8 : Cursor ON                  -\r\n");
	printf("- 9 : Cursor OFF                 -\r\n");
	printf("----------------------------------\r\n");
}

